#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <GLUT/glut.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "paulslib.h"
#include "bitmaplib.h"
#include "opengllib.h"
#include "seriallib.h"

char *interfacestring = "Interface\n\
   Left mouse button            Rotate\n\
   Left mouse button + shift    Pan\n\
   Center mouse button          Roll\n\
   Center mouse button + shift  Forward/reverse\n\
   Right mouse button           Menus\n\
   Arrow keys                   Rotate\n\
   Arrow keys + shift           Pan\n\
   < >                          Forward/reverse\n\
   + -                          Zoom in/out\n\
   [ ]                          Roll\n\
   a A                          Automatic rotation\n\
   i h c                        Info, help, construction\n\
   w                            Screen dump\n\
   q esc                        Quit";

typedef struct {
   XYZ vp;                /* View position           */
   XYZ vd;                /* View direction vector   */
   XYZ vu;                /* View up direction       */
   XYZ pr;                /* Point to rotate about   */
   double focallength;    /* Focal Length along vd   */
   double aperture;       /* Camera aperture         */
   double eyesep;         /* Eye separation          */
	double near,far;       /* Cutting plane distances */
	int stereo;				  /* Are we in stereo mode   */
   int screenwidth;       /* Screen dimensions       */
   int screenheight;      /*                         */
} CAMERA;

typedef struct {
	int debug;             /* Debug mode              */
	int record;            /* Movie recording mode    */
	int windowdump;        /* Image recording modes   */
	int fullscreen;        /* Game mode or not        */
	double targetfps;      /* Target frame rate       */
	int rendermode;        /* Shading type            */
	int showinfo;          /* Display model info      */
	int showhelp;          /* Display help info       */
	int showconstr;        /* Display construction    */
	int autorotate;        /* Spin automatically      */
	int witiltx,witilty,witiltz;
} OPTIONS;

typedef struct {
	int button;
	int shift;
	int mouseh;
	int mousev;
} INTERFACESTATE;
typedef struct {
   int p1,p2,p3;
	int n1,n2,n3;
	int group;
} IPOLYGON;

#define POINTS       0
#define WIREFRAME    1
#define SHADED       2
#define SPECULAR     3

#define NOSTEREO     0
#define ACTIVESTEREO 1
#define DUALSTEREO   2

void CreateMenus(void);
void CreateEnvironment(void);
void MakeLighting(void);
void CreateGeometry(void);

void HandleDisplay(void);
void HandleKeyboard(unsigned char,int,int);
void HandleSpecialKeyboard(int,int,int);
void HandleMouse(int,int,int,int);
void HandleReshape(int,int);
void HandleMouseMotion(int,int);
void HandlePassiveMotion(int,int);
void HandleVisibility(int);
void HandleIdle(void);

void RotateCamera(double,double,double,double);
void TranslateCamera(double,double,double);
void CameraHome(int);

void HandleMainMenu(int);
void HandleCameraMenu(int);
void HandleOptionsMenu(int);
void HandleRenderMenu(int);

void DrawInfoHelp(void);
void GiveUsage(char *);

int ReadObj(FILE *);

void CleanExit(void);
XYZ GetWitiltPoint(void);
void AddWitiltPoint(XYZ);

